package com.io.yutian.gemsystem;

import com.io.yutian.gemsystem.gui.GemGui;
import com.io.yutian.gemsystem.gui.GuiHolder;
import com.io.yutian.gemsystem.listener.GuiListener;
import org.bukkit.Bukkit;
import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.plugin.java.JavaPlugin;

public final class GemSystem extends JavaPlugin {

    private static GemSystem instance;

    @Override
    public void onEnable() {
        instance = this;
        Bukkit.getPluginManager().registerEvents(new GuiListener(), this);

        GemSystemSetting.reload();
    }

    @Override
    public void onDisable() {
        for (Player player : Bukkit.getOnlinePlayers()) {
            if (player.getOpenInventory() != null) {
                InventoryHolder inventoryHolder = player.getOpenInventory().getTopInventory().getHolder();
                if (inventoryHolder instanceof GuiHolder) {
                    player.closeInventory();
                }
            }
        }
    }

    @Override
    public boolean onCommand(CommandSender sender, Command command, String label, String[] args) {
        if (args.length == 1 && args[0].equalsIgnoreCase("reload") && sender.isOp()) {
            GemSystemSetting.reload();
            sender.sendMessage("§8§l[§a§l!§8§l] §7重载成功");
            return true;
        }
        if (!(sender instanceof Player)) {
            return true;
        }
        Player player = (Player) sender;
        new GemGui(player).open();
        return true;
    }

    public static GemSystem inst() {
        return instance;
    }

}
