package com.io.yutian.gemsystem.gui;

import com.io.yutian.gemsystem.util.PlayerInventoryUtil;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.event.inventory.InventoryCloseEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class GemResultGui implements InventoryHolder, GuiHolder {

    private static final ItemStack ITEM_1;
    private static final ItemStack ITEM_2;

    private static final int[] SLOT_ARRAY = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26};
    private static final int SLOT = 13;

    private Inventory inventory;
    private Player player;

    private ItemStack result;
    private boolean success;

    public GemResultGui(Player player, ItemStack result, boolean success) {
        this.player = player;
        this.result = result;
        this.success = success;
        this.inventory = player.getServer().createInventory(this, 27, "宝石合成");
        for (int slot : SLOT_ARRAY) {
            inventory.setItem(slot, success ? ITEM_1 : ITEM_2);
        }
        this.inventory.setItem(SLOT, result);
    }

    @Override
    public void onClick(InventoryClickEvent event) {
        Inventory clickedInventory = event.getClickedInventory();
        int slot = event.getRawSlot();
        event.setCancelled(true);
        if (slot == SLOT) {
            if (result != null) {
                PlayerInventoryUtil.giveItemStack(player, result);
                player.playSound(player.getLocation(), Sound.UI_BUTTON_CLICK, 1, 1);
                result = null;
                player.closeInventory();
            }
        }
    }

    @Override
    public void onClose(InventoryCloseEvent event) {
        if (result != null) {
            PlayerInventoryUtil.giveItemStack(player, result);
        }
    }

    @Override
    public void open() {
        player.openInventory(inventory);
    }

    @Override
    public Inventory getInventory() {
        return inventory;
    }

    static {
        ITEM_1 = new ItemStack(Material.STAINED_GLASS_PANE, 1, (short) 5);
        ITEM_2 = new ItemStack(Material.STAINED_GLASS_PANE, 1, (short) 14);
        ItemMeta itemMeta1 = ITEM_1.getItemMeta();
        itemMeta1.setDisplayName("§a成功");
        ITEM_1.setItemMeta(itemMeta1);
        ItemMeta itemMeta2 = ITEM_2.getItemMeta();
        itemMeta2.setDisplayName("§c失败");
        ITEM_2.setItemMeta(itemMeta2);
    }

}
